
/*
 * $Id: SrvXact.h,v 1.3 1999/04/30 04:47:14 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef SRV_XACTION_H
#define SRV_XACTION_H

#include "Xaction.h"
#include "AlarmClock.h"
#include "ObjTimes.h"
#include "httpHdrs.h"

class Server;
class WrBuf;

class SrvXact: public Xaction, public AlarmUser {
	public:
		SrvXact() { reset(); }
		~SrvXact() {}

		void reset();

		void exec(Server *anOwner, Connection *aConn, Time delay);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);
		virtual void wakeUp(const Alarm &a);

	protected:
		void makeRep(WrBuf &buf);
		void makeRep200(ostream &os);
		void makeRep304(ostream &os);
		void putStdFields(ostream &os) const;

		Size calcRepSize() const;

		void doStart();
		void finish(int errNo);
		virtual void stopStats();

	protected:
		Server *theOwner;
		ReqHdr theReqHdr;

		ObjTimes theTimes;    // mod, lmt, and such
		Size theRepHdrSize;
		Size theRepSize;
		bool isRepCachable;

		Size theProducedSize;
};

#endif

