
/*
 * $Id: WorldOpts.h,v 1.3 1999/04/20 23:10:19 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef WORLD_OPTS
#define WORLD_OPTS

#include "opts.h"

class PopModel;

// popularity model option
class PopMdlOpt: public Opt {
	public:
		PopMdlOpt(OptGrp *aGrp, const char *aName, const char *aDescr, PopModel *def);

		operator void *() const { return theVal ? (void*)-1 : 0; }

		PopModel *model() { return theVal; }

		virtual bool parse(const char *name, const char *val);
		virtual void report() const;

	public:
		PopModel *theVal;
};

// world configuration options
class WorldOpts: public OptGrp {
	public:
		WorldOpts(); // defaults

		virtual bool validate() const;

	public:
		StrOpt theType;
		StrOpt theId;
		StrOpt theUrlsFileName;

		IntOpt theUniqStart;
		IntOpt theReqOrder;

		DblOpt theChbRatio;
		DblOpt theHitRatio;
		PopMdlOpt thePopMdl;

		DistrOpt theTmlDistr;
		IntOpt theTmlDelta;
		IntOpt theTmlDepth;

		IntOpt theExpOidCnt;
		IntOpt thePrefilledCnt;
};

#endif
