
/*
 * $Id: polyOpts.h,v 1.1 1999/04/29 22:54:02 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef POLYGRAPH_OPTS_CLASSES_H
#define POLYGRAPH_OPTS_CLASSES_H

#include "Opt.h"
#include "ObjLifeCycle.h"

// a collection of command line options that are very specific to Poly
// see include/opts.h for more generic ones


// Goal
class GoalOpt: public Opt, public Goal {
	public:
		GoalOpt(OptGrp *aGrp, const char *aName, const char *aDescr);

		virtual bool parse(const char *name, const char *val);
		virtual void report() const;

	protected:
		Goal &theVal;
};


// ObjLifeCycle
class ObjLcOpt: public Opt, public ObjLifeCycle {
	public:
		ObjLcOpt(OptGrp *aGrp, const char *aName, const char *aDescr);

		virtual bool parse(const char *name, const char *val);
		virtual void report() const;

	protected:
		String doParse(const char *name, const char *val);

	protected:
		ObjLifeCycle &theVal;
};


// generic interface, but poly-specific implementation
class VersionOpt: public Opt {
	public:
		VersionOpt(OptGrp *aGrp, const char *aName, const char *aDescr);

		virtual bool parse(const char *name, const char *val);
		virtual void report() const {}
		virtual bool visible() const { return false; }
};


#endif
